
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>独家 | 一文读懂Apache Kudu / iVAN</title>

    <meta name="description" content="独家 | 一文读懂Apache Kudu 前言 Apache Kudu是由Cloudera开源的存储引擎,可以同时提供低延迟的随机读写和高效的数据分析能力.Kudu支持水平扩展,使用Raft协议进行一致性保证,并且与Cloudera Impala和Apache Spark等当前流行的大数据查询和分析工具结 合紧密.本文将为您介绍Kudu的一些基本概念和架构以及在企业中的应用,使您对Kudu有一个较为全面的了解. 一.为什么需要Kudu Kudu这个名字听起来可能有些奇怪,实际上,Kudu是一种非洲的大羚羊,中文名叫&quot;捻角羚&q ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">独家 | 一文读懂Apache Kudu</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvaGVTNndSU0hWTW4wWXB0VlZKdG5BTlJkdU82b1FTYTljeWlhY0hCckhuVDFKQTBZT24yUmljMkc1Z1Z3QThDcEZ4cGljemFKZWRvU3hVUDgxQ2xFWnd1RXcvNjQwP3d4X2ZtdD1wbmcmYW1wO3d4ZnJvbT01JmFtcDt3eF9sYXp5PTE=.jpg"></p>
<p><strong><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvaGVTNndSU0hWTW1pY0c3Nk1ReENROHBIblFHODlqRzNSR2ZJcEhrOHRpYmoyM0wyVmljOExIR1M0OWliWjBFRzlCSUtzd0YwWjJOUTY2M0ZKeEFMbURHNzRBLzY0MD93eF9mbXQ9cG5nJmFtcDt3eGZyb209NSZhbXA7d3hfbGF6eT0x.jpg"></strong></p>
<p><strong>前言</strong></p>
<p><strong><br /></strong></p>
<p>Apache Kudu是由Cloudera开源的存储引擎，可以同时提供低延迟的随机读写和高效的数据分析能力。Kudu支持水平扩展，使用Raft协议进行一致性保证，并且与Cloudera Impala和Apache Spark等当前流行的大数据查询和分析工具结 合紧密。本文将为您介绍Kudu的一些基本概念和架构以及在企业中的应用，使您对Kudu有一个较为全面的了解。</p>
<p><strong>一、为什么需要Kudu</strong></p>
<p>Kudu这个名字听起来可能有些奇怪，实际上，Kudu是一种非洲的大羚羊，中文名叫“捻角羚”，就是下图这个样子：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9qcGcvaGVTNndSU0hWTW1pY0c3Nk1ReENROHBIblFHODlqRzNSbDIwWTFLdTNMaWFHVVhiOWJpYVhIN0l1Y3pxRmljMjl0ZGFNU0NDY1E4a2ZyN2hEYXdldHB5SmJBLzY0MD93eF9mbXQ9anBlZyZhbXA7d3hmcm9tPTUmYW1wO3d4X2xhenk9MQ==.jpg"><br />
<br />比较有意思的是，同为Cloudera公司开源的另一款产品Impala，是另一种非洲的羚羊，叫做“黑斑羚”，也叫“高角羚”。不知道Cloudera公司为什么这么喜欢羚羊，也许是因为羚羊的速度快吧。</p>
<p>言归正传，现在提起大数据存储，我们能想到的技术有很多，比如HDFS，以及在HDFS上的列式存储技术Apache Parquet，Apache ORC，还有以KV形式存储半结构化数据的Apache HBase和Apache Cassandra等等。既然有了如此多的存储技术，Cloudera公司为什么要开发出一款全新的存储引擎Kudu呢？ </p>
<p>事实上，当前的这些存储技术都存在着一定的局限性。对于会被用来进行分析的静态数据集来说，使用Parquet或者ORC存储是一种明智的选择。但是目前的列式存储技术都不能更新数据，而且随机读写性能感人。而可以进行高效随机读写的HBase、Cassandra等数据库，却并不适用于基于SQL的数据分析方向。</p>
<p>所以现在的企业中，经常会存储两套数据分别用于实时读写与数据分析，先将数据写入HBase中，再定期通过ETL到Parquet进行数据同步。但是这样做有很多缺点：</p>
<ul>
<li>用户需要在两套系统间编写和维护复杂的ETL逻辑。</li>
</ul>
<ul>
<li>时效性较差。因为ETL通常是一个小时、几个小时甚至是一天一次，那么可供分析的数据就需要一个小时至一天的时间后才进入到可用状态，也就是说从数据到达到可被分析之间是会存在一个较为明显的“空档期”的。</li>
<li>更新需求难以满足。在实际情况中可能会有一些对已经写入的数据的更新需求，这种情况往往需要对历史数据进行更新，而对Parquet这种静态数据集的更新操作，代价是非常昂贵的。</li>
<li>存储资源浪费。两套存储系统意味着占用的磁盘资源翻倍了，造成了成本的提升。</li>
</ul>
<p>我们知道，基于HDFS的存储技术，比如Parquet，具有高吞吐量连续读取数据的能力；而HBase和Cassandra等技术适用于低延迟的随机读写场景，那么有没有一种技术可以同时具备这两种优点呢？Kudu提供了一种“happy medium”的选择：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvaGVTNndSU0hWTW1pY0c3Nk1ReENROHBIblFHODlqRzNSUU1GTFhLaWE1R0oyMEZYTXhLaWJkVUx2RGg3anQ3ZmRWT2RXNzV6eGRJT2libGVDNG9INWZWMzhRLzY0MD93eF9mbXQ9cG5nJmFtcDt3eGZyb209NSZhbXA7d3hfbGF6eT0x.jpg"><br />
<br />Kudu不但提供了行级的插入、更新、删除API，同时也提供了接近Parquet性能的批量扫描操作。使用同一份存储，既可以进行随机读写，也可以满足数据分析的要求。</p>
<p><strong>二、Kudu总览</strong></p>
<p><strong><br /></strong></p>
<p><strong>Tables和Schemas</strong></p>
<p><strong><br /></strong></p>
<p>从用户角度来看，Kudu是一种存储结构化数据表的存储系统。在一个Kudu集群中可以定义任意数量的table，每个table都需要预先定义好schema。每个table的列数是确定的，每一列都需要有名字和类型，每个表中可以把其中一列或多列定义为主键。这么看来，Kudu更像关系型数据库，而不是像HBase、Cassandra和MongoDB这些NoSQL数据库。不过Kudu目前还不能像关系型数据一样支持二级索引。 Kudu使用确定的列类型，而不是类似于NoSQL的“everything is byte”。这可以带来两点好处：</p>
<ul>
<li>确定的列类型使Kudu可以进行类型特有的编码。</li>
</ul>
<ul>
<li>可以提供 SQL-like 元数据给其他上层查询工具，比如BI工具。</li>
</ul>
<p><strong>读写操作</strong></p>
<p><strong><br /></strong></p>
<p>用户可以使用 Insert，Update和Delete API对表进行写操作。不论使用哪种API，都必须指定主键。但批量的删除和更新操作需要依赖更高层次的组件（比如Impala、Spark）。Kudu目前还不支持多行事务。 而在读操作方面，Kudu只提供了Scan操作来获取数据。用户可以通过指定过滤条件来获取自己想要读取的数据，但目前只提供了两种类型的过滤条件：主键范围和列值与常数的比较。由于Kudu在硬盘中的数据采用列式存储，所以只扫描需要的列将极大地提高读取性能。</p>
<p><strong><br /></strong></p>
<p><strong>一致性模型</strong></p>
<p><strong><br /></strong></p>
<p>Kudu为用户提供了两种一致性模型。默认的一致性模型是snapshot consistency。这种一致性模型保证用户每次读取出来的都是一个可用的快照，但这种一致性模型只能保证单个client可以看到最新的数据，但不能保证多个client每次取出的都是最新的数据。</p>
<p>另一种一致性模型external consistency可以在多个client之间保证每次取到的都是最新数据，但是Kudu没有提供默认的实现，需要用户做一些额外工作。 </p>
<p>为了实现external consistency，Kudu提供了两种方式：</p>
<ul>
<li>在client之间传播timestamp token。在一个client完成一次写入后，会得到一个timestamp token，然后这个client把这个token传播到其他client，这样其他client就可以通过token取到最新数据了。不过这个方式的复杂度很高。</li>
</ul>
<ul>
<li>通过commit-wait方式，这有些类似于Google的Spanner。但是目前基于NTP的commit-wait方式延迟实在有点高。不过Kudu相信，随着Spanner的出现，未来几年内基于real-time clock的技术将会逐渐成熟。</li>
</ul>
<p><strong>三、Kudu的架构</strong></p>
<p><strong><br /></strong></p>
<p>与HDFS和HBase相似，Kudu使用单个的Master节点，用来管理集群的元数据，并且使用任意数量的Tablet Server节点用来存储实际数据。可以部署多个Master节点来提高容错性。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvaGVTNndSU0hWTW1pY0c3Nk1ReENROHBIblFHODlqRzNSZ1d2Y2tuUFZxTTZTZENNdVNtNmpEc054Y1VySFdtT21waWE5ZkV3M1VzWUVpY0diajU5QktNdUEvNjQwP3d4X2ZtdD1wbmcmYW1wO3d4ZnJvbT01JmFtcDt3eF9sYXp5PTE=.jpg"><br /><strong><br /></strong></p>
<p><strong>Master</strong></p>
<p><strong><br /></strong></p>
<p>Kudu的master节点负责整个集群的元数据管理和服务协调。它承担着以下功能：</p>
<ul>
<li>作为catalog manager，master节点管理着集群中所有table和tablet的schema及一些其他的元数据。</li>
</ul>
<ul>
<li>作为cluster coordinator，master节点追踪着所有server节点是否存活，并且当server节点挂掉后协调数据的重新分布。</li>
</ul>
<ul>
<li>作为tablet directory，master跟踪每个tablet的位置。</li>
</ul>
<p><strong><br /></strong></p>
<p><strong>Catalog Manager</strong></p>
<p><strong><br /></strong></p>
<p>Kudu的master节点会持有一个单tablet的table——catalog table，但是用户是不能直接访问的。master将内部的catalog信息写入该tablet，并且将整个catalog的信息缓存到内存中。随着现在商用服务器上的内存越来越大，并且元数据信息占用的空间其实并不大，所以master不容易存在性能瓶颈。catalog table保存了所有table的schema的版本以及table的状态（创建、运行、删除等）。</p>
<p><strong>Cluster Coordination</strong></p>
<p>Kudu集群中的每个tablet server都需要配置master的主机名列表。当集群启动时，tablet server会向master注册，并发送所有tablet的信息。tablet server第一次向master发送信息时会发送所有tablet的全量信息，后续每次发送则只会发送增量信息，仅包含新创建、删除或修改的tablet的信息。 作为cluster coordination，master只是集群状态的观察者。对于tablet server中tablet的副本位置、Raft配置和schema版本等信息的控制和修改由tablet server自身完成。master只需要下发命令，tablet server执行成功后会自动上报处理的结果。</p>
<p><strong>Tablet Directory</strong></p>
<p>因为master上缓存了集群的元数据，所以client读写数据的时候，肯定是要通过master才能获取到tablet的位置等信息。但是如果每次读写都要通过master节点的话，那master就会变成这个集群的性能瓶颈，所以client会在本地缓存一份它需要访问的tablet的位置信息，这样就不用每次读写都从master中获取。 因为tablet的位置可能也会发生变化（比如某个tablet server节点crash掉了），所以当tablet的位置发生变化的时候，client会收到相应的通知，然后再去master上获取一份新的元数据信息。</p>
<p><strong>Tablet存储</strong></p>
<p><strong><br /></strong></p>
<p>在数据存储方面，Kudu选择完全由自己实现，而没有借助于已有的开源方案。tablet存储主要想要实现的目标为：</p>
<ul>
<li>快速的列扫描</li>
</ul>
<ul>
<li>低延迟的随机读写</li>
</ul>
<ul>
<li>一致性的性能</li>
</ul>
<p><strong><br /></strong></p>
<p><strong>RowSets</strong></p>
<p>在Kudu中，tablet被细分为更小的单元，叫做RowSets。一些RowSet仅存在于内存中，被称为MemRowSets，而另一些则同时使用内存和硬盘，被称为DiskRowSets。任何一行未被删除的数据都只能存在于一个RowSet中。 无论任何时候，一个tablet仅有一个MemRowSet用来保存最新插入的数据，并且有一个后台线程会定期把内存中的数据flush到硬盘上。 当一个MemRowSet被flush到硬盘上以后，一个新的MemRowSet会替代它。而原有的MemRowSet会变成一到多个DiskRowSet。flush操作是完全同步进行的，在进行flush时，client同样可以进行读写操作。</p>
<p><strong>MemRowSet</strong></p>
<p><strong><br /></strong></p>
<p>MemRowSets是一个可以被并发访问并进行过锁优化的B-tree，主要是基于MassTree来设计的，但存在几点不同：</p>
<ul>
<li>Kudu并不支持直接删除操作，由于使用了MVCC，所以在Kudu中删除操作其实是插入一条标志着删除的数据，这样就可以推迟删除操作。</li>
</ul>
<ul>
<li>类似删除操作，Kudu也不支持原地更新操作。</li>
</ul>
<ul>
<li>将tree的leaf链接起来，就像B+-tree。这一步关键的操作可以明显地提升scan操作的性能。</li>
</ul>
<ul>
<li>没有实现字典树（trie树），而是只用了单个tree，因为Kudu并不适用于极高的随机读写的场景。</li>
</ul>
<p>与Kudu中其他模块中的数据结构不同，MemRowSet中的数据使用行式存储。因为数据都在内存中，所以性能也是可以接受的，而且Kudu对在MemRowSet中的数据结构进行了一定的优化。</p>
<p><strong>DiskRowSet</strong></p>
<p><strong><br /></strong></p>
<p>当MemRowSet被flush到硬盘上，就变成了DiskRowSet。当MemRowSet被flush到硬盘的时候，每32M就会形成一个新的DiskRowSet，这主要是为了保证每个DiskRowSet不会太大，便于后续的增量compaction操作。Kudu通过将数据分为base data和delta data，来实现数据的更新操作。Kudu会将数据按列存储，数据被切分成多个page，并使用B-tree进行索引。除了用户写入的数据，Kudu还会将主键索引存入一个列中，并且提供布隆过滤器来进行高效查找。</p>
<p><strong>Compaction</strong></p>
<p>为了提高查询性能，Kudu会定期进行compaction操作，合并delta data与base data，对标记了删除的数据进行删除，并且会合并一些DiskRowSet。</p>
<p><strong>分区</strong></p>
<p>和许多分布式存储系统一样，Kudu的table是水平分区的。BigTable只提供了range分区，Cassandra只提供hash分区，而Kudu提供了较为灵活的分区方式。当用户创建一个table时，可以同时指定table的的partition schema，partition schema会将primary key映射为partition key。一个partition schema包括0到多个hash-partitioning规则和一个range-partitioning规则。通过灵活地组合各种partition规则，用户可以创造适用于自己业务场景的分区方式。</p>
<p><strong>四、Kudu的应用</strong></p>
<p>Kudu的应用场景很广泛，比如可以进行实时的数据分析，用于数据可能会存在变化的时序数据应用等，甚至还有人探讨过使用Kudu替代Kafka的可行性（详情请戳  http://blog.rodeo.io/2016/01/24/kudu-as-a-more-flexible-kafka.html）。不过Kudu最有名和最成功的应用案例，还是国内的小米。小米公司不仅使用Kudu，还深度参与了Kudu的开发。Kudu项目在2012年10月由Cloudera公司发起，2015年10月对外公布，2015年12月进入Apache孵化器，但是小米公司早在2014年9月就加入到Kudu的开发中了。 下面我们可以跟随Cloudera在宣传Kudu时使用的ppt来看一看Kudu在小米的使用。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvaGVTNndSU0hWTW1pY0c3Nk1ReENROHBIblFHODlqRzNSeXVnQzVTRUJjWHZxcXdmU0psU0ZydU5taWI3aWNwdUFsNVNjOFdTdjhqSGcyck1CdTkyOXJOOUEvNjQwP3d4X2ZtdD1wbmcmYW1wO3d4ZnJvbT01JmFtcDt3eF9sYXp5PTE=.jpg"></p>
<p>从上图中我们可以看到，Kudu在小米主要用来对手机app和后端服务的RPC调用事件进行追踪，以及对服务进行监控。在小米的使用场景下，Kudu集群已经达到每天200亿次写入，并且还在增长。 Kudu除了优秀的性能，更为重要的是可以简化数据处理的流程。</p>
<p>在使用Kudu以前，小米的数据处理流程是这样的：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvaGVTNndSU0hWTW1pY0c3Nk1ReENROHBIblFHODlqRzNSeEM3V3JRRHpNNVF3cmNTWHlWZ0lVR3MyUUZGeUR4aWNKRjdaamRzcXYwRlRTMWo0bG83cHBPZy82NDA/d3hfZm10PXBuZyZhbXA7d3hmcm9tPTUmYW1wO3d4X2xhenk9MQ==.jpg"><br />
<br />可以看到，数据处理的流程很长。这种处理模式不但较为复杂，而且latency较高，通常需要等待较长的时间（1 hour - 1day）才能得到分析结果。</p>
<p>下面再来看看使用Kudu以后的数据处理流程是怎样的：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvaGVTNndSU0hWTW1pY0c3Nk1ReENROHBIblFHODlqRzNSSDZpYjRmSlNLTGlhRkpBMGdJNlpzVDRUUVFXNFFENFNzb1JZTjhKdEs4NllqRXF4SHN1S01qM3cvNjQwP3d4X2ZtdD1wbmcmYW1wO3d4ZnJvbT01JmFtcDt3eF9sYXp5PTE=.jpg"><br />
<br />使用Kudu以后，数据处理的链路被简化了，而且得益于Kudu对随机读写和数据分析操作的支持都很好，可以直接对Kudu中的数据进行交互式分析，降低了系统复杂度，并且latency被大大缩短（0 ~ 10s）。</p>
<p><strong>五、进一步学习</strong></p>
<p>如果您看了本文的介绍后想进一步学习Kudu，以下途径可以帮助您快速入门：</p>
<ul>
<li>Documentation(http://kudu.apache.org/docs/)，官方文档永远是学习开源项目的最好去处。</li>
</ul>
<ul>
<li>Paper(http://kudu.apache.org/kudu.pdf)，Kudu的论文可以帮助您深入了解Kudu的设计思想。</li>
</ul>
<ul>
<li>Raft协议(https://raft.github.io/)，虽然不属于Kudu的内容，但是Kudu的一致性协议使用了Raft协议，了解Raft协议可以帮助您更好地了解Kudu及其他分布式开源系统。</li>
</ul>
<ul>
<li>Apache Kudu as a More Flexible And Reliable Kafka-style Queue   (http://blog.rodeo.io/2016/01/24/kudu-as-a-more-flexible-kafka.html)，</p>
<p>这篇博客也许能对您在如何使用Kudu的问题上有一些启发。</li>
</ul>
<p>比较遗憾的是，由于Kudu还很年轻，所以并没有比较好的相关书籍出版。计算机是一门实践性较强的学科，所以动手实践是成为Kudu专家的必经之路：github地址(https://github.com/apache/kudu)。</p>
<p>原文发布时间为：2017-08-10 </p>
<p>本文作者：柴诗雨</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-02 12:52:02</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/apache/" title="apache">apache</a>, <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd/" title="性能">性能</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>独家 | 一文读懂Apache Kudu的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze6avOb.html" rel="bookmark">独家 &vert; 一文读懂Hadoop（四）：YARN</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着全球经济的不断发展,大数据时代早已悄悄到来,而Hadoop又是大数据环境的基础,想入门大数据行业首先需要了解Hadoop的知识.2017年年初apache发行了Hadoop3.0,也意味着一直有一群人在对Hadoop不断的做优化,不仅如此,各个Hadoop的商业版本也有好多公司正在使用,这也印证了它的商业价值. 读者可以通过阅读&quot;一文读懂Hadoop&quot;系列文章,对Hadoop技术有个全面的了解,它涵盖了Hadoop官网的所有知识点,并且通俗易懂,英文不好的读者完全可以通过阅读此篇文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVNABYz.html" rel="bookmark">独家 &vert; 一文读懂Hadoop（一）：综述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着全球经济的不断发展,大数据时代早已悄悄到来,而Hadoop又是大数据环境的基础,想入门大数据行业首先需要了解Hadoop的知识.2017年年初apache发行了Hadoop3.0,也意味着一直有一群人在对Hadoop不断的做优化,不仅如此,各个Hadoop的商业版本也有好多公司正在使用,这也印证了它的商业价值. 读者可以通过阅读&quot;一文读懂Hadoop&quot;系列文章,对Hadoop技术有个全面的了解,它涵盖了Hadoop官网的所有知识点,并且通俗易懂,英文不好的读者完全可以通过阅读此篇文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAAq1KM.html" rel="bookmark">独家 &vert; 一文读懂Hadoop（三）：Mapreduce</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着全球经济的不断发展,大数据时代早已悄悄到来,而Hadoop又是大数据环境的基础,想入门大数据行业首先需要了解Hadoop的知识.2017年年初apache发行了Hadoop3.0,也意味着一直有一群人在对Hadoop不断的做优化,不仅如此,各个Hadoop的商业版本也有好多公司正在使用,这也印证了它的商业价值. 读者可以通过阅读&quot;一文读懂Hadoop&quot;系列文章,对Hadoop技术有个全面的了解,它涵盖了Hadoop官网的所有知识点,并且通俗易懂,英文不好的读者完全可以通过阅读此篇文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWNdkz.html" rel="bookmark">独家 &vert; 一文读懂Hadoop（二）HDFS（上）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着全球经济的不断发展,大数据时代早已悄悄到来,而Hadoop又是大数据环境的基础,想入门大数据行业首先需要了解Hadoop的知识.2017年年初apache发行了Hadoop3.0,也意味着一直有一群人在对Hadoop不断的做优化,不仅如此,各个Hadoop的商业版本也有好多公司正在使用,这也印证了它的商业价值. 读者可以通过阅读&quot;一文读懂Hadoop&quot;系列文章,对Hadoop技术有个全面的了解,它涵盖了Hadoop官网的所有知识点,并且通俗易懂,英文不好的读者完全可以通过阅读此篇文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPB23lb.html" rel="bookmark">独家 &vert; 一文读懂Hadoop（二）HDFS（下）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				5.1 用户命令 hadoop集群用户的常用命令. 5.1.1 classpath 打印获取Hadoop jar和所需库所需的类路径.如果无参数调用,则打印由命令脚本设置的类路径,可以在类路径条目中包含通配符.其他选项在通配符扩展后打印类路径或将类路径写入jar文件的清单.后者在不能使用通配符且扩展的类路径超过支持的最大命令行长度的环境中非常有用. 5.1.2 dfs HDFS允许以文件和目录的形式组织用户数据.它提供了一个称为FS shell的命令行界面,允许用户与HDFS中的数据交互.此命令			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0RlZ8z.html" rel="bookmark">独家 &vert; 一文读懂大数据处理框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 说起大数据处理,一切都起源于Google公司的经典论文:&lt;MapReduce:Simplied Data Processing on Large Clusters&gt;.在当时(2000年左右),由于网页数量急剧增加,Google公司内部平时要编写很多的程序来处理大量的原始数据:爬虫爬到的网页.网页请求日志:计算各种类型的派生数据:倒排索引.网页的各种图结构等等.这些计算在概念上很容易理解,但由于输入数据量很大,单机难以处理.所以需要利用分布式的方式完成计算,并且需要考虑如何进行并行计算.分			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVw16Qb.html" rel="bookmark">独家 &vert; 一文读懂推荐系统知识体系-下（评估、实战、学习资料）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文主要阐述: 推荐系统的评估(Evaluation) 推荐系统的冷启动问题(Cold Start) 推荐系统实战(Actual Combat) 推荐系统案例(Case Study) 浏览前三章的内容请见上篇. 如何判断推荐系统的优劣?这是推荐系统评测需要解决的首要问题.一个完整的推荐系统一般存在3个参与方: 用户 物品提供者 提供推荐系统的网站 好的推荐系统设计,能够让推荐系统本身收集到高质量的用户反馈,不断完善推荐的质量,增加用户和网站的交互,提高网站的收入.因此在评测一个推荐算法时,需要同			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8ZPVPb.html" rel="bookmark">独家 &vert; 一文读懂自然语言处理NLP（附学习资料）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言                                               自然语言处理是文本挖掘的研究领域之一,是人工智能和语言学领域的分支学科.在此领域中探讨如何处理及运用自然语言. 对于自然语言处理的发展历程,可以从哲学中的经验主义和理性主义说起.基于统计的自然语言处理是哲学中的经验主义,基于规则的自然语言处理是哲学中的理性主义.在哲学领域中经验主义与理性主义的斗争一直是此消彼长,这种矛盾与斗争也反映在具体科学上,如自然语言处理. 早期的自然语言处理具有鲜明的经验主义			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5ojrqb.html" rel="bookmark">独家 &vert; 一文读懂社交网络分析-上（附学习资源）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文主要阐述: 社交网络的结构特性与演化机理 社交网络群体行为形成与互动规律 社交网络信息传播与演化机理 浏览后四章的内容请见下篇(2017年9月26日二条). 前言 社交网络在维基百科的定义是&quot;由许多节点构成的一种社会结构.节点通常是指个人或组织,而社交网络代表着各种社会关系.&quot;在互联网诞生前,社交网络分析是社会学和人类学重要的研究分支.早期的社交网络的主要指通过合作关系建立起来的职业网络,如科研合作网络.演员合作网络等. 本文所指的社交网络分析专指在线社交网络分析(Online S			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDJlOM.html" rel="bookmark" class="title">循序渐进学习Ajax的途径</a>
					<div>
						ajax 现在浏览器端以 JavaScript 为核心,基于各种 Web 标准(即:早已完成标准化的 XHTML/CSS/DOM/XML/XSLT 和正在进行标准化的 XMLHttpRequest)的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5xE6M.html" rel="bookmark" class="title">Oracle 数据库的备份与恢复</a>
					<div>
						oracle|备份|恢复|数据|数据库 Oracle数据库有三种标准的备份方法,它们分别是导出/导入(EXP/IMP).热备份和冷备份.导出备件是一种逻辑备份,冷备份和热备份是物理备份. 一. 导出/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zelOjp.html" rel="bookmark" class="title">Windows下PHP5和Apache的安装与配置</a>
					<div>
						在这里以PHP5为例介绍一下Windows下Apache和PHP5的安装与配置方法. 一 下载安装程序 Apache可以从http://www.apache.org/dyn/closer.cgi/ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1R9djp.html" rel="bookmark" class="title">Eclipse向导机制扩展</a>
					<div>
						实现动态页数和树状拓扑结构的 Eclipse 向导 本文首先剖析了 Eclipse 向导机制的实现原理,包括页面的加载和注销,页面校验,向导执行流程, 向导目标操作等.目前,Eclipse 向导页面内 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBQwLb.html" rel="bookmark" class="title">Dreamweaver中光标定位不准确问题解决办法</a>
					<div>
						  我以前碰到在Dreamweaver中光标定位不准的问题是在uft-8编码下,但是今天在Dreamweaver CC 设计模式也同样出现此问题了,下面我就整理了一些解决办法,下面我们一起来看看吧.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4v80p.html" rel="bookmark" class="title">金山wps制作优美、有文艺气息的邀请函教程</a>
					<div>
						  插入一张在线文件的图片. 再增加一条丝带,继续在素材里找到丝带的样子. 重新排版,并添加文字. 添加具体时间. 最后把联系方式,报名的联系人,还有其他一些事项写在图片的下方.这样就基本上做好了.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLajw8z.html" rel="bookmark" class="title">云雀361打印共享软件打印图片很模糊怎么办</a>
					<div>
						  打印图片很模糊怎么办? 其实出现打印图片模糊是一般用户都会遇到的情况,一般是黑白打印机打印图片引起的,可以通过设置打印机DPI来缓解,解决办法很简单,只需要调整图形打印质量即可 设置方法: 开始- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7qD8M.html" rel="bookmark" class="title">Photoshop CS6 安装教程</a>
					<div>
						  虽然Adobe公司已宣布放弃CS系列,不过未来还是会继续销售CS6套装软件,尽管只会提供数字版本.photoshop的用户在很长一段时间内估计会继续使用CS系列,Photoshop CS6具备全新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjm3Qnz.html" rel="bookmark" class="title">strut2-Struts2  如何发送参数中带有list对象的请求</a>
					<div>
						问题描述 Struts2 如何发送参数中带有list对象的请求 状态描述: 需要从SSH环境中发送一个POST请求到网络上的某个获取数据的URL,但是此Url的post请求中有一个对象Object1, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOl33kb.html" rel="bookmark" class="title">python提取内容关键词的方法&lowbar;python</a>
					<div>
						本文实例讲述了python提取内容关键词的方法.分享给大家供大家参考.具体分析如下: 一个非常高效的提取内容关键词的python代码,这段代码只能用于英文文章内容,中文因为要分词,这段代码就无能为力了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmKVvz.html" rel="bookmark" class="title">Codeforces 43 A&period; Football</a>
					<div>
						点击打开链接 A. Football time limit per test 2 seconds memory limit per test 256 megabytes input standard  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWnaOp.html" rel="bookmark" class="title">Canary版Chrome浏览器登陆Android 大福利来袭！</a>
					<div>
						目前,谷歌Chrome浏览器会按照稳定性分为四种版本进行推出,包括Canary.Dev.Beta和Stable,其中Canary是最纯粹的尝鲜版本,最不稳定但往往会第一时间上线很多新功能,有点类似微软 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2V3Gb.html" rel="bookmark" class="title">MapXtreme 2005 学习心得 工具&lpar;六&rpar;</a>
					<div>
						在新建的项目中,我们看示例的MapForm.aspx页面上的html代码 上面放了N个工具: 1:MapControl 地图显示工具 &lt;cc1:MapControl ID=&quot;MapCo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWJZ6p.html" rel="bookmark" class="title">java-JAVA多态和非多态有什么区别，觉得没有什么不同啊？</a>
					<div>
						问题描述 JAVA多态和非多态有什么区别,觉得没有什么不同啊? 解决方案 多态是说, 1,假设有个球对象,有子类篮球,乒乓球,羽毛球,每个子类里覆写了父类的tostring方法.. 2,如果你创建三个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boR19Ez.html" rel="bookmark" class="title">MongoDB Replica Set使用几点总结</a>
					<div>
						本文会涉及到MongoDB副本集的初始化,读写性能,scala driver,简单运维等内容. 副本集初始化 在各个节点上replica set进程, nohup numactl --interlea ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3Le8z.html" rel="bookmark" class="title">Deep learning深度学习的十大开源框架</a>
					<div>
						Google开源了TensorFlow(GitHub),此举在深度学习领域影响巨大,因为Google在人工智能领域的研发成绩斐然,有着雄厚的人才储备,而且Google自己的Gmail和搜索引擎都在使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94x3db.html" rel="bookmark" class="title">微软-Microsoft Azure table连接出错</a>
					<div>
						问题描述 Microsoft Azure table连接出错 我要从table里面读数据,之前一直很好用 ,昨天突然读取不了数据了.是我的电脑少装了什么软件吗?sdk有问题?请知道的大神指导一下,谢谢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYdY7p.html" rel="bookmark" class="title">新人求，关于c&num;的dictionary的问题</a>
					<div>
						问题描述 新人求,关于c#的dictionary的问题 有一个简体字和与之对应的繁体字的txt文件,新建一个dictionarydic=new dictionary,如何将txt文件的内容赋值给dic ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkO0AM.html" rel="bookmark" class="title">茶滘村改造首期 安置房顺利封顶</a>
					<div>
						荔湾 茶滘村改造首期 安置房顺利封顶 http://www.aliyun.com/zixun/aggregation/32729.html&quot;&gt;信息时报讯 (记者 成小珍 通讯员 丘礼勇 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNn0OoM.html" rel="bookmark" class="title">智能交通方案推出对互联网巴士有何影响？</a>
					<div>
						2016年8月,国家发改委.交通部印发了&lt;推进&quot;互联网+&quot;便捷交通促进智能交通发展的实施方案&gt;(简称:方案).方案明确,到2018年要基本实现公众可&quot;通过移动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRN0XBM.html" rel="bookmark" class="title">布线须知：无线AP采用PoE交换机供电的好处</a>
					<div>
						现在可以说无线网络已经逐渐取代了有线网络,越来越多的家庭.酒店等都采用无线AP来解决室内无线网络的覆盖问题.不仅移动性高.成本低,而且建设的速度也非常快,能够有效的对移动数据起到分流减压的作用. 在局 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlL50VM.html" rel="bookmark" class="title">《暗黑破坏神3》的网络连接问题，需要进行赔偿</a>
					<div>
						法国消费者团体UFC-Que Choisir因为&lt;暗黑破坏神3&gt;的网络连接问题,要求暴雪在15天内对玩家进行一定程度的赔偿. 暴雪日前就此回应称,他们已经接到了投诉,但网络连接问题事先已经 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0NnKAz.html" rel="bookmark" class="title">mvvm双向绑定机制的原理和实现代码&lpar;推荐&rpar;&lowbar;javascript技巧</a>
					<div>
						mvvm框架的双向绑定,即当对象改变时,自动改变相关的dom元素的值,反之,当dom元素改变时,能自动更新对象的值,当然dom元素一般是指可输出的input元素. 1. 首先实现单向绑定,在指定对象的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGr9o6p.html" rel="bookmark" class="title">编程-南阳理工 素数问题   求大神指教</a>
					<div>
						问题描述 南阳理工 素数问题 求大神指教 素数问题 描述 走进世博园某信息通信馆,参观者将获得前所未有的尖端互动体验,一场充满创想和喜悦的信息通信互动体验秀将以全新形式呈现,从观众踏入展馆的第一步起, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2YyxVz.html" rel="bookmark" class="title">有关android的一个小程序</a>
					<div>
						问题描述 最近发现有一款android的应用,可以查看国内网络上的公共摄像头的实时画面,不知道是什么原理,希望大家帮忙分析一下 问题补充:AngelAndAngel 写道 解决方案 引用所以说,这个玩 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvWLBWp.html" rel="bookmark" class="title">搜索引擎营销</a>
					<div>
						&quot;在瞬息万变的市场竞争中,培训学校的发展速度至关重要,只有快速抢占市场,才能在竞争中获得优势,搜索引擎营销无疑是快速抢占市场最高效.最便捷的好办法&quot;欧朋兰博教育集团的刘老师如是说. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWd0AAp.html" rel="bookmark" class="title">C&plus;&plus;第4周项目2 - 三角形类2</a>
					<div>
						课程首页地址:http://blog.csdn.net/sxhelijian/article/details/7910565,本周题目链接:http://blog.csdn.net/sxhelijia ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0YDY7p.html" rel="bookmark" class="title">轻松自动化---selenium-webdriver&lpar;python&rpar; &lpar;四&rpar;</a>
					<div>
						本节要解决的问题: 如何定位一组元素?   场景 从上一节的例子中可以看出,webdriver可以很方便的使用findElement方法来定位某个特定的对象,不过有时候我们却需要定位一组对象, 这时候 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5YEKAp.html" rel="bookmark" class="title">英特尔内部自主云平台 为95000余名员工服务 - 新闻中心</a>
					<div>
						[赛迪网讯]4月3日消息,据国外http://www.aliyun.com/zixun/aggregation/31646.html&quot;&gt;媒体报道,英特尔不仅在开发云计算及其背后的技术, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zen5Zwb.html" rel="bookmark" class="title">自己做了一个Atm机的程序</a>
					<div>
						问题描述 if(ID());{funcs();}boolean f=ID();if(f){funcs();请问以上这两种代码有什么区别吗.ID()是判断账号密码的方法funcs()是进入1取款.2查询 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
